#!/bin/sh
#
# Test of checkpoint/restart of a csh script.
# Note that "outermost" shell is a bourne shell

# First make certain we *have* a csh
# Exit code 77 tells automake "test skipped"
csh -c true || exit 77

top_builddir=${top_builddir:-..}
export top_builddir

\rm -f Context[123] .Context[123].tmp >& /dev/null 2>/dev/null
sh <<-'__OUTER__'
	exec 2>/dev/null # Drop job control message(s) from the outer script
	$top_builddir/util/cr_run/cr_run csh 2>&1 <<-'__INNER__'
		echo '#ST_IGNORE:^\[1\]' # Tell seq_wrapper to ignore job-control msgs
		echo '#ST_IGNORE:^[ \\011\\015]*$' # ...and the whitespace lines that may accompany them.
		csh <<'__EOF__' &
		    foreach i (0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15)
   	 	    	echo $i Hello
   	 	    	sleep 1
		    end
		'__EOF__'
		set pid=$!
		sleep 3
		echo "# Checkpoint $pid"
		$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context1 --tree --term $pid
		sleep 2
		echo "# Restart $pid"
		$top_builddir/util/cr_restart/cr_restart Context1 &
		set pid=$!
		sleep 4
		echo "# Checkpoint cr_restart of $pid"
		$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context2 --tree --term $pid
		sleep 2
		echo "# Restart cr_restart of $pid"
		$top_builddir/util/cr_restart/cr_restart Context2 &
		sleep 4
		echo "# Checkpoint self"
		$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context3 --tree --term $$
		wait
		echo "16 DONE"
		__INNER__
	exec 2>&1
	sleep 3
	echo "# Restart of shell"
	$top_builddir/util/cr_restart/cr_restart Context3
	__OUTER__
\rm -f Context[123] .Context[123].tmp 2>/dev/null
