#!/bin/sh

# First check that we *have* emacs
emacs -nw -batch 2>/dev/null || exit 77

top_builddir=${top_builddir:-..}
# get a full path
if expr "$top_builddir" : / >/dev/null; then
  : # OK
else
  top_builddir="`pwd`/${top_builddir}"
fi
export top_builddir

\rm -f Context[123] .Context[123].tmp 2>/dev/null
exec 2>/dev/null # To drop job control messages
$top_builddir/util/cr_run/cr_run emacs -nw -q -batch \
 -eval '(defun greet (n)
		(princ (format "%d Hello\n" n))
		(sleep-for 1)
		(if (< n 9) (greet (+ n 1))))' \
 -eval '(defun getpid-ascii () ;; You would think emacslisp would implement getpid()
		(car (split-string  ;; Extract 1st whitespace-delimited field of /proc/sef/stat
			(with-temp-buffer
    				(insert-file-contents-literally "/proc/self/stat")
    				(buffer-string)))))' \
 -eval '(progn
		(greet 0)
		(princ "# Checkpointing self\n")
		(call-process (format "%s/util/cr_checkpoint/cr_checkpoint" (getenv "top_builddir"))
			nil nil nil
			"--file=Context3" "--term" "--tree" (getpid-ascii))
		(princ "10 DONE\n"))' \
  -kill &
pid=$!
sleep 3
echo "# Checkpoint original child"
$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context1 --term $pid 2>&1
wait
sleep 1
echo "# Restart 1"
$top_builddir/util/cr_restart/cr_restart Context1 2>&1 &
pid=$!
sleep 3
echo "# Checkpoint restarted child"
$top_builddir/util/cr_checkpoint/cr_checkpoint --file=Context2 --term --tree $pid 2>&1
wait
sleep 1
echo "# Restart^2"
$top_builddir/util/cr_restart/cr_restart Context2 2>&1 &
wait
echo "# Restart interpreter" # Note entire emacs output still might be bufferd
sleep 2
$top_builddir/util/cr_restart/cr_restart Context3 2>&1
\rm -f Context[123] .Context[123].tmp 2>/dev/null
